* Program Name: error.prg 
* Author: Pat Y. Boens 
* Copyright (c) 1995 by FoxPro Xbase Focus - FoxPro User Group of Belgium
*Ŀ
* Created: 23 February 1995 at 12:23                                      
*                                                                         
* ....................................................................... 
* Revision number : 1.0 Last Revised : 23 February 1995 at 12:23          
* Description : Original Creation.                                        
* ....................................................................... 
*                                                                         
*                                                                         
*                  Ŀ                  
*Ĵ FoxPro Xbase Focus right reserved 
*                         

#define PAVE                    1
#define DALLE                   2

#define GRAY                    RGB( 128,128,128,128,128,128 )
#define LIGHT_GRAY              RGB( 192,192,192,192,192,192 )
#define GRAY_LIGHT              RGB( 128,128,128,192,192,192 )
#define WHITE                   RGB( 255,255,255,255,255,255 )
#define BLACK                   RGB( 0,0,0,0,0,0 )
#define BACKGROUND              RGB( ,,,192,192,192 )

#define MAXIMIZE                ZOOM
#define NOMAXIMIZE              NOZOOM
#define RESIZEABLE              GROW
#define NORESIZEABLE            NOGROW
#define MOVEABLE                FLOAT
#define NOMOVEABLE              NOFLOAT

=Init()                                && Init stage !

? 3 + "Hello"                          && Hope this will generate an error !

DO Eoj                                 && End Of Job

*----------------------------------------------------------------------*

FUNCTION Init

   SET LIBRARY TO FOCUS.FLL
   ON ERROR DO ErrorHandler WITH ERROR()    , ;
                                 MESSAGE()  , ;
                                 MESSAGE(1) , ;
                                 PROGRAM()  , ;
                                 LINENO()   , ;
                                 "Please call <whatever tel number>"

   =FNT_name( "Arial" )
   =FNT_size( 8 )

   =VER_init()                         && Initialize FOCUSversion structure
   =VER_author( "Pat Boens" )          && Author of application
   =VER_name( "Error handler sample" ) && Application name
   =VER_date( "22 Feb 95 12:36" )      && Version date
   =VER_ini( "any.ini" )               && INI file of this application
   =VER_alpha( .T. )                   && This is a alpha version
   =VER_demo( .T. )                    && Demo version
   =VER_major( 1 )                     && Major version number
   =VER_minor( 0 )                     && Minor version number
   =VER_cpyrig( "Copyrights 1995 - FoxPro Xbase Focus" )
   =VER_cargo( "Designed for CompuServe demonstration" )

RETURN ( .T. )

*----------------------------------------------------------------------*

PROCEDURE ErrorHandler
   PARAMETERS m.nErrorCode,m.cDescription,m.cSourceLine,cProc,nSourceLine,m.cCustom

   *-- Ŀ
   *--  PURPOSE : displays information about the error that just     
   *--            occurred. If we can trap error, we'll do it.       
   *--            Otherwise, we simply display the error information 
   *--            and we quit the application "smoothly".            
   *-- 

   PRIVATE aError
   PRIVATE aInternals
   PRIVATE aDisplay
   PRIVATE aOS
   PRIVATE aDBF
   PRIVATE aIOs
   PRIVATE aActions

   PRIVATE m.i

   PRIVATE m.nError
   PRIVATE m.nInternals
   PRIVATE m.nExternals
   PRIVATE m.nSystem
   PRIVATE m.nIOs
   PRIVATE m.nDBF
   PRIVATE m.nActions

   PRIVATE m.cText

   PRIVATE m.nAction1
   PRIVATE m.nAction2

   PRIVATE m.cPrnName
   PRIVATE m.cPrnPort

   IF ( CanTrapError( m.nErrorCode ) )
      && Do something here ... if we can !
   ENDIF

   =PRN_capa()

   m.cPrnName  = PRN_name()           && Printer name
   M.cPrnPort  = PRN_port()           && Printer port

   m.nError     = 1
   m.nInternals = 1
   m.nExternals = 1
   m.nSystem    = 1
   m.nIOs       = 1
   m.nDBF       = 1
   m.nActions   = 1

   m.cText      = ""

   m.nAction1   = 1
   m.nAction2   = 1

   DIMENSION aError[05]
   DIMENSION aInternals[14]
   DIMENSION aExternals[02]
   DIMENSION aSystem[31]
   DIMENSION aIOs[11]
   DIMENSION aDBF[08]
   DIMENSION aActions[02]

   aExternals[01] = "View CONFIG.SYS"
   aExternals[02] = "View AUTOEXEC.BAT"

   aActions[01]   = "Vue positions"
   aActions[02]   = "View DBF structure"

   aInternals[01] = "Menu mapping :"     + IIF( MEN_mappin(),".T.",".F." )
   aInternals[02] = "Mapping tail :"     + ALLTRIM( STR( MEN_tail() ) )
   aInternals[03] = "Event handler :"    + IIF( EVE_isacti(),".T.",".F." )
   aInternals[04] = "READ level :"       + ALLTRIM(STR(RDLEVEL()))
   aInternals[05] = "Trace :"            + ALLTRIM( TRA_getlog() )
   aInternals[06] = "DDA :"              + ALLTRIM( DDA_getlog() )
   aInternals[07] = "Author :"           + VER_author()
   aInternals[08] = "Name :"             + VER_name()
   aInternals[09] = "Date :"             + VER_date()
   aInternals[10] = "INI file :"         + VER_ini()
   aInternals[11] = "Phase :"
   aInternals[12] = "Dmo :"             + IIF( VER_demo(),"True","False" )
   aInternals[13] = "Version :"          + ALLTRIM(STR(VER_major())) + "." + ALLTRIM(STR(VER_minor()))
   aInternals[14] = "Cargo :"            + VER_cargo()

   aSystem[01]    = "Screen driver :"    + SYS_displa()
   aSystem[02]    = "Screen dimension :" + ;
                     ALLTRIM( STR( SCR_cols() ) ) + " x " + ;
                     ALLTRIM( STR( SCR_rows() ) )
   aSystem[03]    = "Country :"            + ALLTRIM( STR( SYS_countr() ) )
   aSystem[04]    = "CPU :"                + SYS(17)
   aSystem[05]    = "CPU mode :"           + IIF( SYS_cpumod() == 0, ;
                                                  "Real mode"      , ;
                                                  "Protected mode" )
   aSystem[06]    = "Available memory :"   + SYS(12)
   aSystem[07]    = "FoxPro memory :"      + SYS(1001)
   aSystem[08]    = "Objects memory :"     + SYS(1016)
   aSystem[09]    = "EMS memory :"         + SYS(23)
   aSystem[10]    = "EMS limit :"          + SYS(24)
   aSystem[11]    = "Program :"            + SYS(16)
   aSystem[12]    = "Resource :"           + SYS(2005)
   aSystem[13]    = "Disks :"              + SYS_dristr()
   aSystem[14]    = "Graphic card :"       + SYS(2006)
   aSystem[15]    = "DOS :"                + ALLTRIM( STR( SYS_dosmaj() ) ) + ;
                                             "." + ALLTRIM( STR( SYS_dosmin() ) )
   aSystem[16]    = "Windows :"            + ALLTRIM( STR( SYS_winmaj() ) ) + ;
                                             "." + ALLTRIM( STR( SYS_winmin() ) )
   aSystem[17]    = "OS mode :"            + ALLTRIM( STR( SYS_osmode() ) )
   aSystem[18]    = "Modem :"              + IIF( SYS_ismode(),".T.",".F." )
   aSystem[19]    = "Printers :"           + ALLTRIM( STR( SYS_numprn() ) )
   aSystem[20]    = "Current printer : "   + m.cPrnName
   aSystem[21]    = "Port :"               + m.cPrnPort
   aSystem[22]    = "Equipment :"          + ALLTRIM( STR( SYS_equip() ) )
   aSystem[23]    = "Video mode :"         + ALLTRIM( STR( SYS_video() ) )
   aSystem[24]    = "Floppi(es) :"         + ALLTRIM( STR( SYS_numflo() ) )
   aSystem[25]    = "Serial ports :"       + ALLTRIM( STR( SYS_rs232() ) )
   aSystem[26]    = "Game adapter :"       + IIF( SYS_isgame(),".T.",".F." )
   aSystem[27]    = "Math co-pro :"        + IIF( SYS_ismath(),".T.",".F." )
   aSystem[28]    = "Mouse driver :"       + SYS_mouse()
   aSystem[29]    = "Network driver :"     + SYS_networ()
   aSystem[30]    = "Prog ID :"            + ALLTRIM( STR( SYS_pgmid() ) )
   aSystem[31]    = "Swap file :"          + SYS_swap()

   aError[01]     = "Error code :"         + ALLTRIM( STR( m.nErrorCode ) )
   aError[02]     = "Desc. :"              + m.cDescription
   aError[03]     = "Code :"               + m.cSourceLine
   aError[04]     = "Procedure :"          + m.cProc
   aError[05]     = "Source line :"        + ALLTRIM( STR( m.nSourceLine ) )

   aDBF[01]       = "DBF :"                + ALIAS()
   aDBF[02]       = "Work area :"          + ALLTRIM( STR( SELECT() ) )
   aDBF[03]       = "Index type :"
   aDBF[04]       = "Index expr :"         + SYS( 14,2 )
   aDBF[05]       = "Index order :"        + SYS( 21 )
   aDBF[06]       = "Index name :"         + SYS( 22 )
   aDBF[07]       = "Index filter :"       + SYS( 2021,2 )
   aDBF[08]       = "Tag name :"           &&+ TAG()

   aIOs[01]       = "Win start :"          + SYS_windir()
   aIOs[02]       = "Win system :"         + SYS_sysdir()
   aIOs[03]       = "Current drive :"      + SYS_curdri()
   aIOs[04]       = "Current dir :"        + CURDIR()
   aIOs[05]       = "Disk space :"         + SYS(2020)
   aIOs[06]       = "Free space :"        + ALLTRIM( STR( SYS_dskspa( SYS_curdri() ) ))
   aIOs[07]       = "Clusters :"           + ALLTRIM( STR( SYS_totclu( SYS_curdri() ) ))
   aIOs[08]       = "Clusters free :"      + ALLTRIM( STR( SYS_avaclu( SYS_curdri() ) ))
   aIOs[09]       = "Bytes/sector :"       + ALLTRIM( STR( SYS_bytsec( SYS_curdri() ) ))
   aIOs[10]       = "Sector/cluster :"     + ALLTRIM( STR( SYS_secclu( SYS_curdri() ) ))
   aIOs[11]       = "Remote ? :"           + IIF( SYS_isremo(SYS_curdri()),".T.",".F." )

   =EVE_end()                         && Stop events polling
   CLEAR READ ALL

   m.cWindow  = WIN_mdialg( 29,124,FNT_name(),8,"",DALLE )

   MOVE WINDOW ( m.cWindow ) CENTER
   ACTIVATE WINDOW ( m.cWindow ) NOSHOW

   =WIN_grave( 00.70,03.00,09.10, 42.00 )
   =WIN_grave( 00.70,43.00,09.10, 82.00 )
   =WIN_grave( 00.70,83.00,09.10,122.00 )

   @ 00.25,05.00 SAY "Objet erreur"   STYLE "B"
   @ 00.25,45.00 SAY "Etat interne"   STYLE "B"
   @ 00.25,85.00 SAY "Externe"        STYLE "B"

   =WIN_grave( 09.70,03.00,18.10, 42.00 )
   =WIN_grave( 09.70,43.00,18.10, 82.00 )
   =WIN_grave( 09.70,83.00,18.10,122.00 )

   @ 09.20,05.00 SAY "Systeme"        STYLE "B"
   @ 09.20,45.00 SAY "I/O disques"    STYLE "B"
   @ 09.20,85.00 SAY "Databases"      STYLE "B"

   =WIN_grave( 18.70,03.00,27.10, 42.00 )
   =WIN_grave( 18.70,43.00,27.10,101.00 )
   =SCR_relief( "RIGOLE",18.70,103.0,27.10,122.00 )

   @ 18.20,05.00 SAY "Actions"        STYLE "B"
   @ 18.20,45.00 SAY "Mmo"           STYLE "B"

   @ 27.50,03.00 SAY m.cCustom        STYLE "B"

   @ 01.30,04.50 GET m.nError                                      ;
                 PICTURE "@&N"                                     ;
                 FROM aError                                       ;
                 SIZE 7,35.4                                       ;
                 COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

   @ 01.30,44.50 GET m.nInternals                                  ;
                 PICTURE "@&N"                                     ;
                 FROM aInternals                                   ;
                 SIZE 7,35.4                                       ;
                 COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

   @ 01.30,84.50 GET m.nExternals                                  ;
                 PICTURE "@&N"                                     ;
                 FROM aExternals                                   ;
                 SIZE 7,35.4                                       ;
                 VALID ShowFile( IIF( m.nExternals == 1          , ;
                                      "C:\CONFIG.SYS"            , ;
                                      "C:\AUTOEXEC.BAT"            ;
                                    )                              ;
                               )                                   ;
                 COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

   *---------------------------------------------------------------*

   @ 10.30,04.50 GET m.nSystem                                     ;
                 PICTURE "@&N"                                     ;
                 FROM aSystem                                      ;
                 SIZE 7,35.4                                       ;
                 COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

   @ 10.30,44.50 GET m.nIOs                                        ;
                 PICTURE "@&N"                                     ;
                 FROM aIOs                                         ;
                 SIZE 7,35.4                                       ;
                 COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

   @ 10.30,84.50 GET m.nDBF                                        ;
                 PICTURE "@&N"                                     ;
                 FROM aDBF                                         ;
                 SIZE 7,35.4                                       ;
                 COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

   *---------------------------------------------------------------*

   @ 19.30,04.50 GET m.nActions                                    ;
                 PICTURE "@&N"                                     ;
                 FROM aActions                                     ;
                 SIZE 7,35.4                                       ;
                 COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)     ;
                 VALID Warning( "Not implemented" )

   @ 19.30,45.00 EDIT m.cText                                      ;
                 SIZE 07.00,55.00,00.00                            ;
                 SCROLL                                            ;
                 COLOR ,RGB(,,,255,255,255)

   *---------------------------------------------------------------*

   @ 20.50,106.0 GET m.nAction1                  ;
                 PICTURE "@*HT OK"               ;
                 SIZE 02.00,13.00,0              ;
                 STYLE "B"

   @ 23.00,106.0 GET m.nAction2                  ;
                 PICTURE "@*HN Log error"        ;
                 SIZE 02.00,13.00,0              ;
                 STYLE "B"                       ;
                 VALID LogError( m.nErrorCode  , ;
                                 m.cDescription, ;
                                 m.cSourceLine , ;
                                 m.cProc       , ;
                                 m.nSourceLine )

   ACTIVATE WINDOW ( m.cWindow )
   READ CYCLE MODAL

   RELEASE WINDOW ( m.cWindow )

RETURN

*----------------------------------------------------------------------------*

FUNCTION LogError
   PARAMETERS m.nErrorCode,m.cDescription,m.cSourceLine,cProc,nSourceLine

   *-- Ŀ
   *--  PURPOSE : logs error to a logging file.                      
   *-- 

   PRIVATE m.nHandle

   IF ( ! FILE( "ERROR.LOG" ) )
      m.nHandle = FCREATE( "ERROR.LOG" )
   ELSE
      m.nHandle = FOPEN( "ERROR.LOG",12 )
      =FSEEK( m.nHandle,0,2 )
   ENDIF

   IF ( m.nHandle >= 0 )
      =FPUTS( m.nHandle,DTOC(DATE()) + " - " + TIME()                 )
      =FPUTS( m.nHandle,"Error #      :" + LTRIM(STR(m.nErrorCode))   )
      =FPUTS( m.nHandle,"Desciption   :" + m.cDescription             )
      =FPUTS( m.nHandle,"Source code  :" + m.cSourceLine              )
      =FPUTS( m.nHandle,"Source line  :" + LTRIM(STR(m.nSourceLine))  )
      =FPUTS( m.nHandle,"Procedure    :" + m.cProc                    )
      =FPUTS( m.nHandle,"Work area    :" + ALIAS()                    )
      =FPUTS( m.nHandle,"Record       :" + LTRIM(STR(RECNO()))        )
      =FPUTS( m.nHandle,"SET ORDER TO :" + ORDER()                    )
      =FPUTS( m.nHandle,REPLICATE( "-",80 )                           )
      =FFLUSH( m.nHandle )
      =FCLOSE( m.nHandle )
   ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION ShowFile
   PARAMETER m.cFile

   *-- Ŀ
   *--  PURPOSE : shows a file (AUTOEXEC.BAT or CONFIG.SYS, etc.)    
   *-- 

   PRIVATE m.cText
   PRIVATE m.nAction
   PRIVATE m.nHandle
   PRIVATE m.cLine

   m.nAction = 1
   m.cText   = ""
   m.nHandle = FOPEN( m.cFile )

   IF ( m.nHandle != -1 )

       DO WHILE ( ! FEOF( m.nHandle ) )
           m.cText = m.cText + FGETS( m.nHandle,254 ) + CHR(13)+CHR(10)
       ENDDO

       =FCLOSE( m.nHandle )

       m.cWindow = WIN_mdialg( 23.00,102.20,FNT_name(),FNT_size(),"View file",DALLE )

       ACTIVATE WINDOW ( m.cWindow ) NOSHOW

       =WIN_grave( 01.00,02.40,06.00,88  )
       =WIN_grave( 01.00,90.00,06.00,100 )

       @ 02.70,92.00 SAY "BUG.BMP" BITMAP

       @ 01.50,03.50 SAY "Viewing " + m.cFile STYLE "B"
       @ 03.00,03.50 SAY "Reading mode"
       @ 04.50,03.50 SAY "Handle : " + ALLTRIM( STR( m.nHandle ) )

       @ 06.50,02.80 EDIT m.cText              ;
                     SIZE 10.50,97.20,00.00    ;
                     SCROLL                    ;
                     COLOR ,RGB( ,,,255,255,255 )

       =SCR_relief( "RIGOLE",17.50,02.40,22,100 )

       @ 18.50,4 GET m.nAction PICTURE "@*BHT ok2.bmp" SIZE 2.5,12,0

       MOVE WINDOW ( m.cWindow ) CENTER
       ACTIVATE WINDOW ( m.cWindow )

       READ CYCLE MODAL

       RELEASE WINDOW ( m.cWindow )

   ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION WIN_mdialg
   PARAMETERS m.nHeight,m.nWidth,m.cFont,m.nSize,m.cTitle,m.nType

   PRIVATE m.cName

   m.cName = SYS( 2015 )              && Generate a random name

   IF ( EMPTY( m.cTitle ) )
       DEFINE WINDOW ( m.cName )            ;
           AT 0,0                           ;
           SIZE m.nHeight,m.nWidth          ;
           FONT m.cFont,m.nSize             ;
           NOMOVEABLE                       ;
           NOCLOSE                          ;
           NONE                             ;
           COLOR BACKGROUND

   ELSE

       DEFINE WINDOW ( m.cName )            ;
           AT 0,0                           ;
           SIZE m.nHeight,m.nWidth          ;
           FONT m.cFont,m.nSize             ;
           TITLE m.cTitle                   ;
           MOVEABLE                         ;
           NOCLOSE                          ;
           NONE                             ;
           COLOR BACKGROUND

   ENDIF

   ACTIVATE WINDOW ( m.cName ) NOSHOW && Activate window but don't show it

   DO CASE                            && What kind of window do we like ?
       CASE ( m.nType == PAVE  )      && Type 1
           DO WIN_pave                && Launch appropriate service

       CASE ( m.nType == DALLE )      && Type 2
           DO WIN_dalle               && Launch appropriate service

   ENDCASE

   MOVE WINDOW (m.cName) CENTER       && Center window

RETURN ( m.cName )

*----------------------------------------------------------------------*

FUNCTION WIN_grave
   PARAMETERS m.nTop,m.nLeft,m.nBottom,m.nRight

   *-- Ŀ
   *--  PURPOSE : Draw a carved line in a specific region.           
   *-- 

   PRIVATE m.nH
   PRIVATE m.nW
   PRIVATE m.cFont
   PRIVATE m.nSize

   m.cFont = WFONT( 1 )
   m.nSize = WFONT( 2 )

   m.nH    = 1 / FONTMETRIC( 1,m.cFont,m.nSize )
   m.nW    = 1 / FONTMETRIC( 6,m.cFont,m.nSize )

   @ m.nTop     ,m.nLeft      TO m.nBottom     ,m.nRight      PEN 0 COLOR GRAY
   @ m.nTop+m.nH,m.nLeft+m.nW TO m.nBottom+m.nH,m.nRight+m.nW PEN 0 COLOR WHITE

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION CanTrapError
   PARAMETER m.nErrorCode

RETURN ( .T. )

*----------------------------------------------------------------------*

PROCEDURE WIN_dalle

   PRIVATE m.nTop
   PRIVATE m.nLeft
   PRIVATE m.nRight
   PRIVATE m.nBottom
   PRIVATE m.nRightLeft
   PRIVATE m.nBottomTop

   * Map screen coordinates to window coordinates

   m.nTop    = 0.2                    && 0.5
   m.nLeft   = 0.5                    && 0.7
   m.nRight  = WCOLS() - .16
   m.nBottom = WROWS() - .1

   m.nRightLeft = m.nRight  - m.nLeft && 1 calculation only
   m.nBottomTop = m.nBottom - m.nTop  && 1 calculation only

   * Dark edge along top of indented area
   *-------------------------------------
   @ m.nTop,m.nLeft       TO m.nTop,m.nRightLeft         PEN 0 COLOR GRAY


   * Dark edge along left side of indented area
   *-------------------------------------------
   @ m.nTop,m.nLeft       TO m.nBottomTop,m.nLeft        PEN 0 COLOR GRAY


   * Dark edge along bottom
   *-----------------------
   @ m.nBottom,0          TO m.nBottom,m.nRight          PEN 0 COLOR GRAY


   * Dark edge along right side
   *---------------------------
   @ 0,m.nRight           TO m.nBottom,m.nRight          PEN 0 COLOR GRAY


   * Light edge along top
   *---------------------
   @ 0,0                  TO 0,m.nRight                  PEN 0 COLOR WHITE


   * Light edge down left side
   *--------------------------
   @ 0,0                  TO m.nBottom,0                 PEN 0 COLOR WHITE


   * Light edge along bottom of indented area
   *-----------------------------------------
   @ m.nBottomTop,m.nLeft TO m.nBottomTop,m.nRightLeft   PEN 0 COLOR WHITE


   * Light edge along right side of indented area
   *---------------------------------------------
   @ m.nTop,m.nRightLeft    TO m.nBottomTop,m.nRightLeft PEN 0 COLOR WHITE

RETURN

*----------------------------------------------------------------------*

FUNCTION SCR_relief
   PARAMETERS m.cType,m.nTop,m.nLeft,m.nBottom,m.nRight

   PRIVATE m.nEcart,m.nEcartc
   PRIVATE m.cFont
   PRIVATE m.nSize

   m.cFont   = WFONT( 1 )
   m.nSize   = WFONT( 2 )

   m.nEcart  = 3/FONTMETRIC( 1,m.cFont,m.nSize )
   m.nEcartc = 3/FONTMETRIC( 6,m.cFont,m.nSize )

   IF ( m.nBottom > WROWS() )
       m.nBottom = WROWS() - 0.500
   ENDIF

   IF ( m.nRight > WCOLS() )
       m.nRight = WCOLS() - 0.500
   ENDIF

   DO CASE
       CASE ( m.cType = "OMBRE" )
           @ m.nTop   ,m.nLeft    TO m.nBottom,m.nLeft  PEN 1,8           COLOR WHITE
           @ m.nTop   ,m.nLeft    TO m.nTop   ,m.nRight PEN 1,8 STYLE "1" COLOR WHITE
           @ m.nTop   ,m.nRight   TO m.nBottom,m.nRight PEN 1,8
           @ m.nBottom,m.nLeft    TO m.nBottom,m.nRight PEN 1,8 STYLE "1"

       CASE ( m.cType = "TRANCHEE" )
           @ m.nTop   ,m.nLeft    TO m.nBottom,m.nLeft  PEN 1,8
           @ m.nTop   ,m.nLeft    TO m.nTop   ,m.nRight PEN 1,8 STYLE "1"
           @ m.nTop   ,m.nRight   TO m.nBottom,m.nRight PEN 1,8           COLOR WHITE
           @ m.nBottom,m.nLeft    TO m.nBottom,m.nRight PEN 1,8 STYLE "1" COLOR WHITE

       CASE ( m.cType = "RIGOLE" )
           @ m.nTop   ,m.nLeft    TO m.nBottom,m.nLeft  PEN 1,8
           @ m.nTop   ,m.nLeft    TO m.nTop   ,m.nRight PEN 1,8 STYLE "1"
           @ m.nTop   ,m.nRight   TO m.nBottom,m.nRight PEN 1,8           COLOR WHITE
           @ m.nBottom,m.nLeft    TO m.nBottom,m.nRight PEN 1,8 STYLE "1" COLOR WHITE

           @ m.nTop    + m.nEcart    , ;
             m.nLeft   + m.nEcartc TO  ;
             m.nBottom - m.nEcart    , ;
             m.nLeft   + m.nEcartc     ;
           PEN 1,8                     ;
           COLOR WHITE

           @ m.nTop    + m.nEcart    , ;
             m.nLeft   + m.nEcartc TO  ;
             m.nTop    + m.nEcart    , ;
             m.nRight  - m.nEcartc     ;
           PEN 1,8                     ;
           STYLE "1"                   ;
           COLOR WHITE

           @ m.nTop    + m.nEcart    , ;
             m.nRight  - m.nEcartc TO  ;
             m.nBottom - m.nEcart    , ;
             m.nRight  - m.nEcartc     ;
           PEN 1, 8

           @ m.nBottom - m.nEcart    , ;
             m.nLeft   + m.nEcartc TO  ;
             m.nBottom - m.nEcart    , ;
             m.nRight  - m.nEcartc     ;
           PEN 1,8                     ;
           STYLE "1"

   ENDCASE

RETURN ( .T. )

*----------------------------------------------------------------------*

PROCEDURE Eoj

    RELEASE ALL
    CLEAR ALL

    SET LIBRARY TO

RETURN

*----------------------------------------------------------------------*

FUNCTION Warning
   PARAMETER m.cString

   =WIN_nowait( m.cString )

RETURN ( .T. )
